/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAdsConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAdsConnectorForm{}

// GoogleAdsConnectorForm struct for GoogleAdsConnectorForm
type GoogleAdsConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// OAuthId
	OAuthId *string `json:"oAuthId,omitempty"`
	// Data source label
	Label *string `json:"label,omitempty"`
	// Customer Id
	CustomerId *string `json:"customerId,omitempty"`
	// Customer Client Id
	CustomerClientId *string `json:"customerClientId,omitempty"`
	// Attribute
	Attribute []string `json:"attribute,omitempty"`
	// Segment
	Segment []string `json:"segment,omitempty"`
	// Metric
	Metric []string `json:"metric,omitempty"`
	// Report type
	ReportType *string `json:"reportType,omitempty"`
	// Date range.
	DateRange *string `json:"dateRange,omitempty"`
}

// NewGoogleAdsConnectorForm instantiates a new GoogleAdsConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAdsConnectorForm(connectorId string, templateId string, strategy string) *GoogleAdsConnectorForm {
	this := GoogleAdsConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	return &this
}

// NewGoogleAdsConnectorFormWithDefaults instantiates a new GoogleAdsConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAdsConnectorFormWithDefaults() *GoogleAdsConnectorForm {
	this := GoogleAdsConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *GoogleAdsConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *GoogleAdsConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *GoogleAdsConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *GoogleAdsConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *GoogleAdsConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *GoogleAdsConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *GoogleAdsConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *GoogleAdsConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *GoogleAdsConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleAdsConnectorForm) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleAdsConnectorForm) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *GoogleAdsConnectorForm) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *GoogleAdsConnectorForm) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *GoogleAdsConnectorForm) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *GoogleAdsConnectorForm) SetLabel(v string) {
	o.Label = &v
}

// GetCustomerId returns the CustomerId field value if set, zero value otherwise.
func (o *GoogleAdsConnectorForm) GetCustomerId() string {
	if o == nil || IsNil(o.CustomerId) {
		var ret string
		return ret
	}
	return *o.CustomerId
}

// GetCustomerIdOk returns a tuple with the CustomerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorForm) GetCustomerIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerId) {
		return nil, false
	}
	return o.CustomerId, true
}

// HasCustomerId returns a boolean if a field has been set.
func (o *GoogleAdsConnectorForm) HasCustomerId() bool {
	if o != nil && !IsNil(o.CustomerId) {
		return true
	}

	return false
}

// SetCustomerId gets a reference to the given string and assigns it to the CustomerId field.
func (o *GoogleAdsConnectorForm) SetCustomerId(v string) {
	o.CustomerId = &v
}

// GetCustomerClientId returns the CustomerClientId field value if set, zero value otherwise.
func (o *GoogleAdsConnectorForm) GetCustomerClientId() string {
	if o == nil || IsNil(o.CustomerClientId) {
		var ret string
		return ret
	}
	return *o.CustomerClientId
}

// GetCustomerClientIdOk returns a tuple with the CustomerClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorForm) GetCustomerClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerClientId) {
		return nil, false
	}
	return o.CustomerClientId, true
}

// HasCustomerClientId returns a boolean if a field has been set.
func (o *GoogleAdsConnectorForm) HasCustomerClientId() bool {
	if o != nil && !IsNil(o.CustomerClientId) {
		return true
	}

	return false
}

// SetCustomerClientId gets a reference to the given string and assigns it to the CustomerClientId field.
func (o *GoogleAdsConnectorForm) SetCustomerClientId(v string) {
	o.CustomerClientId = &v
}

// GetAttribute returns the Attribute field value if set, zero value otherwise.
func (o *GoogleAdsConnectorForm) GetAttribute() []string {
	if o == nil || IsNil(o.Attribute) {
		var ret []string
		return ret
	}
	return o.Attribute
}

// GetAttributeOk returns a tuple with the Attribute field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorForm) GetAttributeOk() ([]string, bool) {
	if o == nil || IsNil(o.Attribute) {
		return nil, false
	}
	return o.Attribute, true
}

// HasAttribute returns a boolean if a field has been set.
func (o *GoogleAdsConnectorForm) HasAttribute() bool {
	if o != nil && !IsNil(o.Attribute) {
		return true
	}

	return false
}

// SetAttribute gets a reference to the given []string and assigns it to the Attribute field.
func (o *GoogleAdsConnectorForm) SetAttribute(v []string) {
	o.Attribute = v
}

// GetSegment returns the Segment field value if set, zero value otherwise.
func (o *GoogleAdsConnectorForm) GetSegment() []string {
	if o == nil || IsNil(o.Segment) {
		var ret []string
		return ret
	}
	return o.Segment
}

// GetSegmentOk returns a tuple with the Segment field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorForm) GetSegmentOk() ([]string, bool) {
	if o == nil || IsNil(o.Segment) {
		return nil, false
	}
	return o.Segment, true
}

// HasSegment returns a boolean if a field has been set.
func (o *GoogleAdsConnectorForm) HasSegment() bool {
	if o != nil && !IsNil(o.Segment) {
		return true
	}

	return false
}

// SetSegment gets a reference to the given []string and assigns it to the Segment field.
func (o *GoogleAdsConnectorForm) SetSegment(v []string) {
	o.Segment = v
}

// GetMetric returns the Metric field value if set, zero value otherwise.
func (o *GoogleAdsConnectorForm) GetMetric() []string {
	if o == nil || IsNil(o.Metric) {
		var ret []string
		return ret
	}
	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorForm) GetMetricOk() ([]string, bool) {
	if o == nil || IsNil(o.Metric) {
		return nil, false
	}
	return o.Metric, true
}

// HasMetric returns a boolean if a field has been set.
func (o *GoogleAdsConnectorForm) HasMetric() bool {
	if o != nil && !IsNil(o.Metric) {
		return true
	}

	return false
}

// SetMetric gets a reference to the given []string and assigns it to the Metric field.
func (o *GoogleAdsConnectorForm) SetMetric(v []string) {
	o.Metric = v
}

// GetReportType returns the ReportType field value if set, zero value otherwise.
func (o *GoogleAdsConnectorForm) GetReportType() string {
	if o == nil || IsNil(o.ReportType) {
		var ret string
		return ret
	}
	return *o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorForm) GetReportTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ReportType) {
		return nil, false
	}
	return o.ReportType, true
}

// HasReportType returns a boolean if a field has been set.
func (o *GoogleAdsConnectorForm) HasReportType() bool {
	if o != nil && !IsNil(o.ReportType) {
		return true
	}

	return false
}

// SetReportType gets a reference to the given string and assigns it to the ReportType field.
func (o *GoogleAdsConnectorForm) SetReportType(v string) {
	o.ReportType = &v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *GoogleAdsConnectorForm) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorForm) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *GoogleAdsConnectorForm) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *GoogleAdsConnectorForm) SetDateRange(v string) {
	o.DateRange = &v
}

func (o GoogleAdsConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAdsConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.CustomerId) {
		toSerialize["customerId"] = o.CustomerId
	}
	if !IsNil(o.CustomerClientId) {
		toSerialize["customerClientId"] = o.CustomerClientId
	}
	if !IsNil(o.Attribute) {
		toSerialize["attribute"] = o.Attribute
	}
	if !IsNil(o.Segment) {
		toSerialize["segment"] = o.Segment
	}
	if !IsNil(o.Metric) {
		toSerialize["metric"] = o.Metric
	}
	if !IsNil(o.ReportType) {
		toSerialize["reportType"] = o.ReportType
	}
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	return toSerialize, nil
}

type NullableGoogleAdsConnectorForm struct {
	value *GoogleAdsConnectorForm
	isSet bool
}

func (v NullableGoogleAdsConnectorForm) Get() *GoogleAdsConnectorForm {
	return v.value
}

func (v *NullableGoogleAdsConnectorForm) Set(val *GoogleAdsConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAdsConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAdsConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAdsConnectorForm(val *GoogleAdsConnectorForm) *NullableGoogleAdsConnectorForm {
	return &NullableGoogleAdsConnectorForm{value: val, isSet: true}
}

func (v NullableGoogleAdsConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAdsConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
